pcl::Keypoint< PointInT, PointOutT > Class Template Referenceabstract
Module keypoints

Keypoint represents the base class for key points. More...

`#include <pcl/keypoints/keypoint.h>`

Inheritance diagram for pcl::Keypoint< PointInT, PointOutT >:

## Public Types

typedef boost::shared_ptr< Keypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointInT, PointOutT > > | ConstPtr
typedef PCLBase< PointInT > | BaseClass
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual bool | initCompute ()
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual void | detectKeypoints (PointCloudOut &output)=0
| Abstract key point detection method. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT>
class pcl::Keypoint< PointInT, PointOutT >

Keypoint represents the base class for key points.

Author
  Bastian Steder

Definition at line 55 of file keypoint.h.

## Member Typedef Documentation

template<typename PointInT, typename PointOutT>

typedef PCLBase<PointInT> pcl::Keypoint< PointInT, PointOutT >::BaseClass

Definition at line 64 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef boost::shared_ptr<const Keypoint<PointInT, PointOutT> > pcl::Keypoint< PointInT, PointOutT >::ConstPtr

Definition at line 59 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef pcl::search::Search<PointInT> pcl::Keypoint< PointInT, PointOutT >::KdTree

Definition at line 65 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef pcl::search::Search<PointInT>::Ptr pcl::Keypoint< PointInT, PointOutT >::KdTreePtr

Definition at line 66 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef pcl::PointCloud<PointInT> pcl::Keypoint< PointInT, PointOutT >::PointCloudIn

Definition at line 67 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef PointCloudIn::ConstPtr pcl::Keypoint< PointInT, PointOutT >::PointCloudInConstPtr

Definition at line 69 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef PointCloudIn::Ptr pcl::Keypoint< PointInT, PointOutT >::PointCloudInPtr

Definition at line 68 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef pcl::PointCloud<PointOutT> pcl::Keypoint< PointInT, PointOutT >::PointCloudOut

Definition at line 70 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef boost::shared_ptr<Keypoint<PointInT, PointOutT> > pcl::Keypoint< PointInT, PointOutT >::Ptr

Definition at line 58 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef boost::function<int (int, double, std::vector<int> &, std::vector<float> &)> pcl::Keypoint< PointInT, PointOutT >::SearchMethod

Definition at line 71 of file keypoint.h.

template<typename PointInT, typename PointOutT>

typedef boost::function<int (const PointCloudIn &cloud, int index, double, std::vector<int> &, std::vector<float> &)> pcl::Keypoint< PointInT, PointOutT >::SearchMethodSurface

Definition at line 72 of file keypoint.h.

## Constructor & Destructor Documentation

template<typename PointInT, typename PointOutT>

pcl::Keypoint< PointInT, PointOutT >::Keypoint | ( |  | ) |

inline

Empty constructor.

Definition at line 76 of file keypoint.h.

template<typename PointInT, typename PointOutT>

virtual pcl::Keypoint< PointInT, PointOutT >::~Keypoint | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 89 of file keypoint.h.

## Member Function Documentation

template<typename PointInT , typename PointOutT >

void pcl::Keypoint< PointInT, PointOutT >::compute | ( | PointCloudOut & | output | ) |

inline

Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  output | the resultant point cloud model dataset containing the estimated features

Definition at line 124 of file keypoint.hpp.

Referenced by pcl::Keypoint< PointT, PointT >::getKeypointsIndices().

template<typename PointInT, typename PointOutT>

virtual void pcl::Keypoint< PointInT, PointOutT >::detectKeypoints | ( | PointCloudOut & | output | ) |

protected pure virtual

Abstract key point detection method.

Implemented in pcl::AgastKeypoint2D< PointInT, PointOutT >, pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >, pcl::AgastKeypoint2DBase< PointInT, PointOutT, pcl::common::IntensityFieldAccessor< PointInT > >, pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >, pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >, pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >, pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >, pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >, pcl::SIFTKeypoint< PointInT, PointOutT >, pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >, pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >, and pcl::SmoothedSurfacesKeypoint< PointT, PointNT >.

Referenced by pcl::Keypoint< PointT, PointT >::getClassName().

template<typename PointInT, typename PointOutT>

const std::string& pcl::Keypoint< PointInT, PointOutT >::getClassName | ( |  | ) | const

inline protected

Get a string representation of the name of this class.

Definition at line 201 of file keypoint.h.

template<typename PointInT, typename PointOutT>

pcl::PointIndicesConstPtr pcl::Keypoint< PointInT, PointOutT >::getKeypointsIndices | ( |  | ) |

inline

Returns
  the keypoints indices in the input cloud.

Note
  not all the daughter classes populate the keypoints indices so check emptiness before use.

Definition at line 140 of file keypoint.h.

template<typename PointInT, typename PointOutT>

int pcl::Keypoint< PointInT, PointOutT >::getKSearch | ( |  | ) |

inline

get the number of k nearest neighbors used for the feature estimation.

Definition at line 123 of file keypoint.h.

template<typename PointInT, typename PointOutT>

double pcl::Keypoint< PointInT, PointOutT >::getRadiusSearch | ( |  | ) |

inline

Get the sphere radius used for determining the neighbors.

Definition at line 134 of file keypoint.h.

template<typename PointInT, typename PointOutT>

KdTreePtr pcl::Keypoint< PointInT, PointOutT >::getSearchMethod | ( |  | ) |

inline

Get a pointer to the search method used.

Definition at line 109 of file keypoint.h.

template<typename PointInT, typename PointOutT>

double pcl::Keypoint< PointInT, PointOutT >::getSearchParameter | ( |  | ) |

inline

Get the internal search parameter.

Definition at line 113 of file keypoint.h.

template<typename PointInT, typename PointOutT>

PointCloudInConstPtr pcl::Keypoint< PointInT, PointOutT >::getSearchSurface | ( |  | ) |

inline

Get a pointer to the surface point cloud dataset.

Definition at line 99 of file keypoint.h.

template<typename PointInT , typename PointOutT >

bool pcl::Keypoint< PointInT, PointOutT >::initCompute | ( |  | ) |

protected virtual

Reimplemented in pcl::AgastKeypoint2DBase< PointInT, PointOutT, IntensityT >, pcl::AgastKeypoint2DBase< PointInT, PointOutT, pcl::common::IntensityFieldAccessor< PointInT > >, pcl::AgastKeypoint2DBase< pcl::PointXYZ, pcl::PointUV, pcl::common::IntensityFieldAccessor< pcl::PointXYZ > >, pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >, pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >, pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >, pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >, pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >, pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >, pcl::SIFTKeypoint< PointInT, PointOutT >, and pcl::SmoothedSurfacesKeypoint< PointT, PointNT >.

Definition at line 43 of file keypoint.hpp.

Referenced by pcl::Keypoint< PointT, PointT >::searchForNeighbors().

template<typename PointInT, typename PointOutT>

int pcl::Keypoint< PointInT, PointOutT >::searchForNeighbors | ( | int | index,
|  | double | parameter,
|  | std::vector< int > & | indices,
|  | std::vector< float > & | distances
| ) |  | const

inline

Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.

Parameters

  index | the index of the query point
  parameter | the search parameter (either k or radius)
  indices | the resultant vector of indices representing the k-nearest neighbors
  distances | the resultant vector of distances representing the distances from the query point to the k-nearest neighbors

Definition at line 158 of file keypoint.h.

template<typename PointInT, typename PointOutT>

void pcl::Keypoint< PointInT, PointOutT >::setKSearch | ( | int | k | ) |

inline

Set the number of k nearest neighbors to use for the feature estimation.

Parameters

  k | the number of k-nearest neighbors

Definition at line 119 of file keypoint.h.

template<typename PointInT, typename PointOutT>

void pcl::Keypoint< PointInT, PointOutT >::setRadiusSearch | ( | double | radius | ) |

inline

Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection.

Parameters

  radius | the sphere radius used as the maximum distance to consider a point a neighbor

Definition at line 130 of file keypoint.h.

template<typename PointInT, typename PointOutT>

void pcl::Keypoint< PointInT, PointOutT >::setSearchMethod | ( | const KdTreePtr & | tree | ) |

inline

Provide a pointer to the search object.

Parameters

  tree | a pointer to the spatial search object.

Definition at line 105 of file keypoint.h.

template<typename PointInT, typename PointOutT>

virtual void pcl::Keypoint< PointInT, PointOutT >::setSearchSurface | ( | const PointCloudInConstPtr & | cloud | ) |

inline virtual

Provide a pointer to the input dataset that we need to estimate features at every point for.

Parameters

  cloud | the const boost shared pointer to a PointCloud message

Definition at line 95 of file keypoint.h.

## Member Data Documentation

template<typename PointInT, typename PointOutT>

int pcl::Keypoint< PointInT, PointOutT >::k_

protected

The number of K nearest neighbors to use for each point.

Definition at line 194 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::getKSearch(), and pcl::Keypoint< PointT, PointT >::setKSearch().

template<typename PointInT, typename PointOutT>

pcl::PointIndicesPtr pcl::Keypoint< PointInT, PointOutT >::keypoints_indices_

protected

Indices of the keypoints in the input cloud.

Definition at line 197 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::getKeypointsIndices().

template<typename PointInT, typename PointOutT>

std::string pcl::Keypoint< PointInT, PointOutT >::name_

protected

The key point detection method's name.

Definition at line 173 of file keypoint.h.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::HarrisKeypoint3D(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::HarrisKeypoint6D(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::ISSKeypoint3D(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::SUSANKeypoint(), pcl::TrajkovicKeypoint2D< PointInT, PointOutT, IntensityT >::TrajkovicKeypoint2D(), and pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::TrajkovicKeypoint3D().

template<typename PointInT, typename PointOutT>

SearchMethod pcl::Keypoint< PointInT, PointOutT >::search_method_

protected

The search method template for indices.

Definition at line 176 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::searchForNeighbors().

template<typename PointInT, typename PointOutT>

SearchMethodSurface pcl::Keypoint< PointInT, PointOutT >::search_method_surface_

protected

The search method template for points.

Definition at line 179 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::searchForNeighbors().

template<typename PointInT, typename PointOutT>

double pcl::Keypoint< PointInT, PointOutT >::search_parameter_

protected

The actual search parameter (casted from either search_radius_ or k_).

Definition at line 188 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::getSearchParameter().

template<typename PointInT, typename PointOutT>

double pcl::Keypoint< PointInT, PointOutT >::search_radius_

protected

The nearest neighbors search radius for each point.

Definition at line 191 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::getRadiusSearch(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::HarrisKeypoint3D(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::HarrisKeypoint6D(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::ISSKeypoint3D(), pcl::Keypoint< PointT, PointT >::setRadiusSearch(), and pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::SUSANKeypoint().

template<typename PointInT, typename PointOutT>

PointCloudInConstPtr pcl::Keypoint< PointInT, PointOutT >::surface_

protected

An input point cloud describing the surface that is to be used for nearest neighbors estimation.

Definition at line 182 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::getSearchSurface(), pcl::Keypoint< PointT, PointT >::searchForNeighbors(), pcl::Keypoint< PointT, PointT >::setSearchSurface(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setSearchSurface(), and pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::setSearchSurface().

template<typename PointInT, typename PointOutT>

KdTreePtr pcl::Keypoint< PointInT, PointOutT >::tree_

protected

A pointer to the spatial search object.

Definition at line 185 of file keypoint.h.

Referenced by pcl::Keypoint< PointT, PointT >::getSearchMethod(), and pcl::Keypoint< PointT, PointT >::setSearchMethod().

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/keypoints/include/pcl/keypoints/keypoint.h
- /build/pcl-6_P28C/pcl-1.7.2/keypoints/include/pcl/keypoints/impl/keypoint.hpp